/***************************************************************************
 * MoioChart Library - graphs and charts made easy                         *
 * Copyright (C) 2005 by Silvio Moioli                                     *
 * silvio@moioli.net, http://www.moioli.net                                *  
 *                                                                         *
 * This program is free software; you can redistribute it and/or           *
 * modify it under the terms of the GNU General Public License             *
 * as published by the Free Software Foundation; either version 2          *
 * of the License, or (at your option) any later version.                  *
 *                                                                         *
 * This program is distributed in the hope that it will be useful,         *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of          *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           *
 * GNU General Public License for more details.                            *
 *                                                                         *
 * You should have received a copy of the GNU General Public License       *
 * along with this program; if not, write to the Free Software             *
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,              *
 * MA  02110-1301, USA.                                                    *
 ***************************************************************************/

package net.moioli.chart.sw.demos;

import net.moioli.chart.sw.SWGraph;
import net.moioli.drawables.ParsedFunction;
import net.moioli.drawables.ParsedSeries;
import net.moioli.drawables.ParsedSuccession;
import sxwaba.ui.BoxBase;
import sxwaba.ui.HBox;
import sxwaba.ui.VBox;
import waba.fx.Color;
import waba.ui.Container;
import waba.ui.ControlEvent;
import waba.ui.Edit;
import waba.ui.Event;
import waba.ui.MainWindow;
import waba.ui.Radio;
import waba.ui.RadioGroup;

/**
 * @author silvio
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class Main extends MainWindow {
    BoxBase graphControls = new VBox();
    BoxBase editButton = new HBox();
    BoxBase radioButtons = new HBox();

    SWGraph swg = new SWGraph();
    
    Edit toParse = new Edit("");
    //Button redraw = new Button("Draw");
    
    RadioGroup rg = new RadioGroup();
    Radio radioFunction = new Radio("Function",this.rg); 
    Radio radioSuccession = new Radio("Succession",this.rg); 
    Radio radioSeries = new Radio("Series",this.rg); 
    
    Container c1 = new Container();
    Container c2 = new Container();
    Container c3 = new Container();
    
    public void onStart()
    {
       //init components
        this.rg.add(this.radioFunction);
        this.rg.add(this.radioSuccession);
        this.rg.add(this.radioSeries);
        this.c1.setBorderStyle(BORDER_SIMPLE);
        this.c2.setBorderStyle(BORDER_SIMPLE);
        this.c3.setBorderStyle(BORDER_SIMPLE);
        this.toParse.setBackColor(Color.WHITE);

        this.c1.add(this.radioFunction);
        this.c2.add(this.radioSuccession);
        this.c3.add(this.radioSeries);
       
       try{
           this.toParse.setText("atan(x)");
           this.rg.setSelectedIndex(0);
           this.swg.getGraph().setMinX(-10);
           this.swg.getGraph().setMaxX(10);
           this.swg.add(new ParsedFunction(this.toParse.getText()));
       }
       catch (Exception cantHappen){
           //Impossible
       }
       
       //add components

       //first row: the graph      
       this.graphControls.add(this.swg,6);
       
       //Second row: edit and button
       this.editButton.add(this.toParse);
       //editButton.add(redraw,1);
       this.graphControls.add(this.editButton,1);
       
       //Third row: radio buttons
       this.radioButtons.add(this.c1,1);
       this.radioButtons.add(this.c2,1);
       this.radioButtons.add(this.c3,1);
       this.graphControls.add(this.radioButtons,1);
       
       //finish
       add(this.graphControls);
       this.graphControls.setRect(getClientRect());
       this.radioFunction.setRect(1,1,FILL-1,FILL-1,this.c1);
       this.radioSuccession.setRect(1,1,FILL-1,FILL-1,this.c2);
       this.radioSeries.setRect(1,1,FILL-1,FILL-1,this.c3);

    }
    
    public void onEvent(Event event)
    {
       if (event.type== ControlEvent.PRESSED){
           try{
               this.swg.clear();
               this.toParse.setBackColor(Color.WHITE);
               this.toParse.repaintNow();
               switch (this.rg.getSelectedIndex()){
                   case 0: 
                       this.swg.getGraph().setMinX(-10);
                       this.swg.getGraph().setMaxX(10);
                       this.swg.add(new ParsedFunction(this.toParse.getText()));
                       break;
                   case 1:
                       this.swg.getGraph().setMinX(0);
                       this.swg.getGraph().setMaxX(20);
                       this.swg.add(new ParsedSuccession(this.toParse.getText()));
                       break;
                   case 2:
                       this.swg.getGraph().setMinX(0);
                       this.swg.getGraph().setMaxX(20);
                       this.swg.add(new ParsedSeries(0,this.toParse.getText()));
                       break;
                   default:break;
               }
           }
           catch(Exception cantHappen){
               this.toParse.setBackColor(new Color(255,0,0));
               this.toParse.repaintNow();
           }
       }
    } 
}
